#include <stdlib.h>
/*-----------------------------------------------------------------*/
/*  Numerote les aretes et construit Tleft,Tright,lowV,highV,edgeT */
typedef int triangle[3];
/*  OUTPUT */
extern int ne; /*    ne =ns+nt- nbre trous 	(=nbre d'aretes) */
extern int* lowV; /* lowV[ne] numero du sommet debut d'arete */
extern int* highV; /*  highV[ne]   no sommet debut et fin d'arete */
extern int* Tleft; /* Tleft[ne] no du triangle a gauche de l'arete */
extern int* Tright; /* Tright[ne]  no du triangle a droite de l'arete */
extern triangle* edgeT;/* edgeT[nt][3] no des 3 aretes de chaque tr  */
extern int* listHead; /* listHead[ns] no d'un tr ayant ce i pour sommet*/
/*--------------------------------------------------------------*/
int doedge(int ns, int nt, triangle* me)
/*--------------------------------------------------------------*/
{
int found, i,k,j,l,lp, low, high,ip;
int* list=NULL; /* tableau auxiliaire */
int next[4]={1,2,0,1};
ne=-1;
list = (int*)calloc(50+ns+nt,sizeof(int)); /* 50 trous max */
lowV = (int*)calloc(50+ns+nt,sizeof(int));
highV = (int*)calloc(50+ns+nt,sizeof(int));
Tleft = (int*)calloc(50+ns+nt,sizeof(int));
Tright = (int*)calloc(50+ns+nt,sizeof(int));
edgeT = (triangle*)calloc(nt,sizeof(triangle));
listHead = (int*)calloc(ns, sizeof(int));
for(k=0;k<nt+ns+50;k++){Tright[k]=Tleft[k]=-1;}
for(k=0;k<nt;k++)							
  	for(l=0;l<=2;l++)
    {
     	lp=next[l];
     	i=me[k][lp]	;		/* sommet depart de l'arete */
     	j=me[k][next[lp]];	/* sommet fin de l'arete */
     	low= i>j ? j : i;	/* le + petit dans low  */
     	high= i>j ? i : j;
     	ip=listHead[low];		/* debut de la liste d'arete  */
        found=0;
        while(( ip!= 0)&&(!found)) 
		{
      		if(ip>49+ns+nt)
      			printf("bug in doedge\n");
      		if( (high==highV[ip] )&& ( low == lowV[ip] ) )
        	{					/*  l'arete est deja construite  */
        		edgeT[k][l]= ip;/* stocker l'arete  */
        		if (low==i)  Tleft[ip] = k;
        			else Tright[ip]=k;/* triangle a droite de ip  */
       			found=1;
      		}
      		ip=list[ip]	;		/* l'arete suivante dans la liste */
     	}
   		if(!found)				/*  trouve' une nouvelle arete  */
   		{
       		lowV[++ne]=low	;	/*  on stocke le sommet depart */
	   		highV[ne]=high;		/*  on stocke le sommet fin  */
	   		list[ne]=listHead[low];	/*  on ajoute a la liste  */
	   		listHead[low]=ne;	/*  on remet ca comme depart */
	   		if (low == i)	
	   				Tleft[ne]=k;	/* 	triangle a gauche  */
	   		else	Tright[ne] = k;      
	   		edgeT[k][l]=ne;
		}
	}
	for(k=0;k<nt;k++)
		for(i=0;i<=2;i++)	/* le sommet i est dans le tr listHead[j] */
			listHead[me[k][i]]=k;
	free((void**)&list); 
  return 0;
}
