         PROGRAM  Chaleur
         PARAMETER (M=10)						!!{   nombre de points x}
         PARAMETER (dx = 0.1)	!!{ taille du maillage}
         PARAMETER (kmax = 20)		!!{ nb. iter Gauss-Seidel}
         DIMENSION  teta(M), alpha(M)
         CALL entredon (xkappa,tetaa,tetab,teta0,alpha,M)
         CALL  init (teta,M, tetaa,tetab)
         DO 1 k=1, kmax
  1      CALL relax (teta,alpha, M,dx,xkappa,teta0)
         write(*,*) 'plot'
         pause
         CALL  plotresult(teta,M)
         pause
         END

         SUBROUTINE relax ( teta,alpha, M,dx,xkappa,teta0) 
         DIMENSION  teta(*),alpha(*) !!{  iter. Gauss-Seidel}
         xkappadx2 = xkappa/dx/dx				
         DO 1 im = 2,  M - 1
1         teta(im) = (xkappadx2 * (teta(im+1) + teta(im-1))
     >    + alpha(im) * teta0) / (alpha(im)+  2 *
     >      xkappadx2)
         END

         SUBROUTINE init (teta,M, tetaa,tetab)
         DIMENSION teta(*)
         DO 1 im = 1 , M
1         teta(im)=tetaa*(M-im)/(M-1.)+tetab*(im-1.)/(M-1.)
         END

         SUBROUTINE entredon (xkappa,tetaa,tetab,
     >                         teta0,alpha,M)
         DIMENSION alpha(*)
         write(*,*) 'kappa?'
         read(*,*) xkappa
         write(*,*) 'teta0?'
         read(*,*) teta0
         write(*,*) 'tetaa?'
         read(*,*) tetaa
         write(*,*) 'tetab?'
         read(*,*) tetab
         DO 1 im=1,M
           write(*,*) 'alpha[', im, ']?'
1          read(*,*) alpha(im)
         END

         SUBROUTINE plotresult(teta,M)
         DIMENSION teta(*)
         iteta = teta(1) * 10		!!{  change l" echelle}
         CALL moveto(100, iteta)			!!{  bouge le curseur} 
         DO 1 im=2,M
           iteta =teta(im) * 10
           im10=100+im * 10
1        CALL lineto(im10, iteta)		!!{  trace}
         END

         include grafic.for !!{ contient moveto et lineto}
