C Fichier: elem.for
C
C---------------------------------------------------
       FUNCTION elemMat(k,il,jl,airek,q,me)
C---------------------------------------------------
C Calcule la contribution elementaire sur le triangle
C d"indice k de l"element d"indice i,j de la matrice
C A, i.e. $A_{ij}(T_k)$, ou i et j sont les indices 
C des sommets d'indices locaux il et jl dans le triangle
C (i.e. i=me(il,k), j=me(jl,k)).
C L"aire du triangle est donnee en entree (airek).
C 
C
C N.B. Ce sous-programme suppose les triangles 
C      orientes positivement.
C
C
      DIMENSION q(2,*), me(3,*), isuiv(4)
      DATA isuiv/2,3,1,2/
      ip=me(isuiv(il),k)
      ipp=me(isuiv(il+1),k)
      jp=me(isuiv(jl),k)
      jpp=me(isuiv(jl+1),k)
      elemMat= ( (q(2,ip)-q(2,ipp))*(q(2,jp)-q(2,jpp))
     >+ (q(1,ip)-q(1,ipp))*(q(1,jp)-q(1,jpp)))/(4*airek)
      END
C
C
