C Fichier ICholes.for
C
C
C-----------------------------------------
      SUBROUTINE ICholeski(ns,aa,ia,ja,al)
C-----------------------------------------
C Ce sous-programme effectue la factorisation de
C Choleski incomplete de la matrice A stockee sous
C forme Morse dans le tableau aa avec les tableaux
C auxiliaires d"indices ia et ja.
C ia(k): indice dans le tableau aa du premier element
C   de la i eme ligne de A stocke dans aa,
C ja(k): indice j de colonne de l"element Aij stocke
C   dans le tableau aa a l"indice k.
C Le resultat est stocke dans le tableau al, qui 
C utilise les memes tableaux auxiliaires d"indices
C ia et ja que aa.
C Le calcul de la factorisation incomplete se fait
C ligne par ligne en terminant par le calcul de 
C l"element diagonal.
C
C
      INTEGER ia(*), ja(*)
      DIMENSION aa(*),al(*)
C
      DO 30 i=1,ns
        DO 34 k=ia(i),ia(i+1)-2
          j=ja(k)
          alij=aa(k)
          ik=ia(i)
          jk=ia(j)
35	      IF(ik.LE.(ia(i+1)-2)) THEN
            jlik=ja(ik)
36	        IF(jk.LE.(ia(j+1)-2)) THEN
              jljk=ja(jk)
              IF(jlik.GT.jljk)THEN
                jk=jk+1
                GOTO 36
              ELSEIF(jlik.LT.jljk)THEN
                  ik=ik+1
                  GOTO 35
              ELSE
                alij=alij-al(ik)*al(jk)
                ik=ik+1
                jk=jk+1
                GOTO 35
              ENDIF
            ENDIF
          ENDIF
          al(k)=alij/al(ia(j+1)-1)
34      CONTINUE
        alii=aa(ia(i+1)-1)
        DO 33 k=ia(i), ia(i+1)-2
          alii=alii-al(k)**2
33      CONTINUE
          al(ia(i+1)-1)=sqrt(abs(alii))
30    CONTINUE
      END
